package com.jeesharp.business.modules.mall.controller;

import com.jeesharp.business.modules.mall.application.MallFirstOrderConfigApplicationService;
import com.jeesharp.business.modules.mall.dto.MallFirstOrderConfigSaveDTO;
import com.jeesharp.business.modules.mall.vo.MallFirstOrderConfigListVO;
import com.jeesharp.business.modules.mall.vo.MallFirstOrderConfigInfoVO;
import com.jeesharp.business.modules.mall.vo.MallFirstOrderConfigQueryVO;
import com.jeesharp.framework.pojo.AjaxResult;
import com.jeesharp.framework.pojo.Page;
import com.jeesharp.framework.pojo.query.PageRespVO;
import com.jeesharp.framework.web.controller.BaseController;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import jakarta.validation.Valid;

/**
 * 首单优惠配置管理 Controller
 */
@RestController
@RequestMapping(value = "${jeesharp.web.adminPath}/manager/business/mall/firstOrderConfig/v1")
@Tag(name = "首单优惠配置管理")
@AllArgsConstructor
public class MallFirstOrderConfigController extends BaseController {

    private final MallFirstOrderConfigApplicationService mallFirstOrderConfigApplicationService;

    @Operation(summary = "获取详情")
    @GetMapping(value = "info")
    public AjaxResult<MallFirstOrderConfigInfoVO> info(@RequestParam("id") String id) {
        MallFirstOrderConfigInfoVO vo = mallFirstOrderConfigApplicationService.get(id);
        return AjaxResult.okData(vo);
    }

    @Operation(summary = "获取列表（分页）")
    @PostMapping(value = "list")
    public AjaxResult<PageRespVO<MallFirstOrderConfigListVO>> list(@RequestBody MallFirstOrderConfigQueryVO query) {
        PageRespVO<MallFirstOrderConfigListVO> page = mallFirstOrderConfigApplicationService.findPage(new Page<>(query), query);
        return AjaxResult.okData(page);
    }

    @Operation(summary = "保存")
    @PostMapping(value = "save")
    public AjaxResult<Void> save(@RequestBody @Valid MallFirstOrderConfigSaveDTO dto) {
        mallFirstOrderConfigApplicationService.save(dto);
        return AjaxResult.ok("保存成功");
    }

    @Operation(summary = "删除")
    @GetMapping(value = "delete")
    public AjaxResult<Void> delete(@RequestParam("ids") String ids) {
        mallFirstOrderConfigApplicationService.delete(ids);
        return AjaxResult.ok("删除成功");
    }
}
